package eu.semiramis.attribute;

import java.io.Serializable;
import java.util.Locale;

import eu.semiramis.federationproxy.translation_old.TranslationManager;
import eu.semiramis.util.xstream.XStreamUtil;

public abstract class AttributeBean implements Serializable{
	protected String attributeId = null;
	protected boolean attributeMandatoryFlag = false;
	protected boolean attributeForbiddenFlag = false;
	

	public AttributeBean translate(String fromResourceBundleBaseName, Locale fromLocale, String toResourceBundleBaseName, Locale toLocale) throws Exception{
		String fromClassName = this.getClass().getName();
		String toClassName = TranslationManager.translateLabel(fromResourceBundleBaseName, fromLocale, toResourceBundleBaseName, toLocale, fromClassName);
		Class<?> toClass = Class.forName(toClassName);
		AttributeBean toAttributeBean = (AttributeBean)toClass.newInstance();
		toAttributeBean.setAttributeId(this.getAttributeId());
		toAttributeBean = translate(toAttributeBean, fromResourceBundleBaseName, fromLocale, toResourceBundleBaseName, toLocale);
		return toAttributeBean;
	}
	
	public static AttributeBean getInstance(String attributeBeanStream){
		AttributeBean attributeBean = null;
		if (attributeBeanStream != null){
			try {
				attributeBean = (AttributeBean)XStreamUtil.loadXmlBeanInstanceFromStream(attributeBeanStream);
			} catch (Exception e){
				attributeBean = null;
			}
		}
		return attributeBean;
	}
	protected abstract AttributeBean translate(AttributeBean toAttributeBean, String fromResourceBundleBaseName, Locale fromLocale, String toResourceBundleBaseName, Locale toLocale) throws Exception;

	public String toXml(){
		String attributeBeanStream = XStreamUtil.toXml(this);
		return attributeBeanStream;
	}
	public String getAttributeId() {
		return attributeId;
	}

	public void setAttributeId(String attributeId) {
		this.attributeId = attributeId;
	}

	public boolean getAttributeMandatoryFlag() {
		return attributeMandatoryFlag;
	}

	public void setAttributeMandatoryFlag(boolean attributeMandatoryFlag) {
		this.attributeMandatoryFlag = attributeMandatoryFlag;
	}

	public boolean getAttributeForbiddenFlag() {
		return attributeForbiddenFlag;
	}

	public void setAttributeForbiddenFlag(boolean attributeForbiddenFlag) {
		this.attributeForbiddenFlag = attributeForbiddenFlag;
	}
	
}
