package eu.semiramis.attribute;

import java.util.Locale;

import com.thoughtworks.xstream.XStream;

import eu.semiramis.federationproxy.translation_old.TranslationManager;
import eu.semiramis.util.encode.EncodeUtil;
import eu.semiramis.util.file.FileUtil;
import eu.semiramis.util.xstream.XStreamUtil;

public class LabelAttributeBean extends AttributeBean{
	private String attributeLabel = null;

	public AttributeBean translate(AttributeBean toAttributeBean, String fromResourceBundleBaseName, Locale fromLocale, String toResourceBundleBaseName, Locale toLocale) throws Exception {
		if (toAttributeBean instanceof LabelAttributeBean){
			LabelAttributeBean toLabelAttributeBean = (LabelAttributeBean) toAttributeBean;
			String fromAttributeLabel = this.getAttributeLabel();
			String toAttributeLabel = TranslationManager.translateLabel(fromResourceBundleBaseName, fromLocale, toResourceBundleBaseName, toLocale, fromAttributeLabel);
			toLabelAttributeBean.setAttributeLabel(toAttributeLabel);
		}
		return toAttributeBean;
	}
	public String getAttributeLabel() {
		return attributeLabel;
	}
	public void setAttributeLabel(String attributeLabel) {
		this.attributeLabel = attributeLabel;
	}
	
	public static void main(String[] args){
		try {
			LabelAttributeBean labelAttributeBean = new LabelAttributeBean();
			labelAttributeBean.setAttributeId("lavelAddreess");
			labelAttributeBean.setAttributeLabel(EncodeUtil.encode("direccin", EncodeUtil.ENCODING_ISO88591, EncodeUtil.ENCODING_UTF8));
			XStreamUtil.saveXmlBeanInstance(labelAttributeBean, "D:/semiramis/projectDev/devConfig/AttributeBean/labelAttributeBean_address_es.xml");
		} catch (Exception e){
			e.printStackTrace();
		}
	}
}
