package eu.semiramis.federationproxy;

import java.io.Serializable;
import java.security.cert.X509Certificate;
import java.util.List;
import java.util.Locale;

import org.opensaml.common.SAMLObject;
import org.opensaml.saml2.core.Assertion;
import org.opensaml.saml2.core.Conditions;

public class ProxyBean implements Serializable {

	private SAMLObject		sourceSamlObject = null;
	private String			sourceRelayState = null;
	private String			proxyUrl = null;
	private boolean			proxyValidateSignFlag = true;
	private Boolean			proxyValidateSignAchievedFlag = null;
	private boolean		 	proxySignFlag = false;
	private Boolean			proxySignAchievedFlag = null;	
	private String			proxyValidateSignCertFilePath = null;	
	private boolean		 	proxyEncryptFlag = false;
	private Integer		 	proxyEncryptAchievedAssertionNumber = null;
	private String		 	proxyEncryptCertFilePath = null;
	/*private Locale		 	proxyFromLocale = null;
	private String		 	proxyFromResourceBundleBaseName = null;
	private Locale		 	proxyToLocale = null;
	private String		 	proxyToResourceBundleBaseName = null;
	*/
	private boolean			fromIA = true; //to identify the direction of the translation 

	private String			proxyRelayState = null;	
	private String			proxySamlIssuer = null;
	private String			proxySamlIdpProvider = null;
	private String			proxySamlSubjectNameId = null;
	private String			proxySamlSubjectNameQualifier = null;
	private Conditions		proxySamlConditions = null;
	private List<Assertion>	proxySamlAssertionList = null;
	private String			proxySamlActionId = null;
	private String			proxySamlResourceId = null;
	private String 		 	proxySamlInResponseTo = null;
	private int 		 	proxySamlInResponseToType = 0;
	private Boolean  	 	proxySamlResponseStatusCodeSuccessFlag = null;
	private SAMLObject		targetSamlObject = null;
	private String 			proxyStatusCode = null;
	private String 			proxyStatusMessage = null;	
	private X509Certificate proxySamlOriginCertificate = null;
	private String			proxySamlOriginIssuer = null;
	
	public String getProxyStatusMessage() {
		return proxyStatusMessage;
	}
	public void setProxyStatusMessage(String proxyStatusMessage) {
		this.proxyStatusMessage = proxyStatusMessage;
	}
	
	public boolean isFromIA() {
		return fromIA;
	}
	public void setFromIA(boolean fromIA) {
		this.fromIA = fromIA;
	}
	
	public X509Certificate getProxySamlOriginCertificate() {
		return proxySamlOriginCertificate;
	}
	public void setProxySamlOriginCertificate(
			X509Certificate proxySamlOriginCertificate) {
		this.proxySamlOriginCertificate = proxySamlOriginCertificate;
	}
	public String getProxySamlOriginIssuer() {
		return proxySamlOriginIssuer;
	}
	public void setProxySamlOriginIssuer(String proxySamlOriginIssuer) {
		this.proxySamlOriginIssuer = proxySamlOriginIssuer;
	}
		
	public SAMLObject getSourceSamlObject() {
		return sourceSamlObject;
	}
	public void setSourceSamlObject(SAMLObject sourceSamlObject) throws Exception{
		this.sourceSamlObject = sourceSamlObject;		
		if (sourceSamlObject == null){
			throw new Exception("NullSourceSamlObject");
		}
	}
	public String getSourceRelayState() {
		return sourceRelayState;
	}
	public void setSourceRelayState(String sourceRelayState) {
		this.sourceRelayState = sourceRelayState;
	}
    
	public String getProxyValidateSignCertFilePath() {
		return proxyValidateSignCertFilePath;
	}
	public void setProxyValidateSignCertFilePath(String proxyValidateSignCertFilePath) {
		this.proxyValidateSignCertFilePath = proxyValidateSignCertFilePath;
	}
	public boolean getProxyValidateSignFlag() {
		return proxyValidateSignFlag;
	}
	public void setProxyValidateSignFlag(boolean proxyValidateSignFlag) {
		this.proxyValidateSignFlag = proxyValidateSignFlag;
	}
	public Boolean getProxyValidateSignAchievedFlag() {
		return proxyValidateSignAchievedFlag;
	}
	public void setProxyValidateSignAchievedFlag(boolean proxyValidateSignAchievedFlag) {
		this.proxyValidateSignAchievedFlag = new Boolean(proxyValidateSignAchievedFlag);
	}
	public String getProxySamlIssuer() {
		return proxySamlIssuer;
	}
	public void setProxySamlIssuer(String proxySamlIssuer) {
		this.proxySamlIssuer = proxySamlIssuer;
	}
	public String getProxySamlIdpProvider() {
		return proxySamlIdpProvider;
	}
	public void setProxySamlIdpProvider(String proxySamlIdpProvider) {
		this.proxySamlIdpProvider = proxySamlIdpProvider;
	}
	public String getProxySamlSubjectNameId() {
		return proxySamlSubjectNameId;
	}
	public void setProxySamlSubjectNameId(String proxySamlSubjectNameId) {
		this.proxySamlSubjectNameId = proxySamlSubjectNameId;
	}
	public String getProxySamlSubjectNameQualifier() {
		return proxySamlSubjectNameQualifier;
	}
	public void setProxySamlSubjectNameQualifier(String proxySamlSubjectNameQualifier) {
		this.proxySamlSubjectNameQualifier = proxySamlSubjectNameQualifier;
	}
	
	public String getProxySamlActionId() {
		return proxySamlActionId;
	}
	public void setProxySamlActionId(String proxySamlActionId) {
		this.proxySamlActionId = proxySamlActionId;
	}
	
	public String getProxySamlResourceId() {
		return proxySamlResourceId;
	}
	public void setProxySamlResourceId(String proxySamlResourceId) {
		this.proxySamlResourceId = proxySamlResourceId;
	}
	public String getProxyRelayState() {
		return proxyRelayState;
	}
	public void setProxyRelayState(String proxyRelayState) {
		this.proxyRelayState = proxyRelayState;
	}
	public String getProxyUrl() {
		return proxyUrl;
	}
	public void setProxyUrl(String proxyUrl) {
		this.proxyUrl = proxyUrl;
	}
	public boolean getProxySignFlag() {
		return proxySignFlag;
	}
	public void setProxySignFlag(boolean proxySignFlag) {
		this.proxySignFlag = proxySignFlag;
	}
	public Boolean getProxySignAchievedFlag() {
		return proxySignAchievedFlag;
	}
	public void setProxySignAchievedFlag(boolean proxySignAchievedFlag) {
		this.proxySignAchievedFlag = new Boolean(proxySignAchievedFlag);
	}
	public boolean getProxyEncryptFlag() {
		return proxyEncryptFlag;
	}
	public void setProxyEncryptFlag(boolean proxyEncryptFlag) {
		this.proxyEncryptFlag = proxyEncryptFlag;
	}
	public Integer getProxyEncryptAchievedAssertionNumber() {
		return proxyEncryptAchievedAssertionNumber;
	}
	public void setProxyEncryptAchievedAssertionNumber(Integer proxyEncryptAchievedAssertionNumber) {
		this.proxyEncryptAchievedAssertionNumber = proxyEncryptAchievedAssertionNumber;
	}
	public String getProxyEncryptCertFilePath() {
		return proxyEncryptCertFilePath;
	}
	public void setProxyEncryptCertFilePath(String proxyEncryptCertFilePath) {
		this.proxyEncryptCertFilePath = proxyEncryptCertFilePath;
	}
	/*public Locale getProxyFromLocale() {
		return proxyFromLocale;
	}
	public void setProxyFromLocale(Locale proxyFromLocale) {
		this.proxyFromLocale = proxyFromLocale;
	}
	public String getProxyFromResourceBundleBaseName() {
		return proxyFromResourceBundleBaseName;
	}
	public void setProxyFromResourceBundleBaseName(String proxyFromResourceBundleBaseName) {
		this.proxyFromResourceBundleBaseName = proxyFromResourceBundleBaseName;
	}
	public Locale getProxyToLocale() {
		return proxyToLocale;
	}
	public void setProxyToLocale(Locale proxyToLocale) {
		this.proxyToLocale = proxyToLocale;
	}
	public String getProxyToResourceBundleBaseName() {
		return proxyToResourceBundleBaseName;
	}
	public void setProxyToResourceBundleBaseName(
			String proxyToResourceBundleBaseName) {
		this.proxyToResourceBundleBaseName = proxyToResourceBundleBaseName;
	}*/
	public Conditions getProxySamlConditions() {
		return proxySamlConditions;
	}
	public void setProxySamlConditions(Conditions proxySamlConditions) {
		this.proxySamlConditions = proxySamlConditions;
	}
	public List<Assertion> getProxySamlAssertionList() {
		return proxySamlAssertionList;
	}
	public void setProxySamlAssertionList(List<Assertion> proxySamlAssertionList) {
		this.proxySamlAssertionList = proxySamlAssertionList;
	}
	public String getProxySamlInResponseTo() {
		return proxySamlInResponseTo;
	}
	public void setProxySamlInResponseTo(String proxySamlInResponseTo) {
		this.proxySamlInResponseTo = proxySamlInResponseTo;
	}
	public int getProxySamlInResponseToType() {
		return proxySamlInResponseToType;
	}
	public void setProxySamlInResponseToType(int proxySamlInResponseToType) {
		this.proxySamlInResponseToType = proxySamlInResponseToType;
	}
	public Boolean getProxySamlResponseStatusCodeSuccessFlag() {
		return proxySamlResponseStatusCodeSuccessFlag;
	}
	public void setProxySamlResponseStatusCodeSuccessFlag(Boolean proxySamlResponseStatusCodeSuccessFlag) {
		this.proxySamlResponseStatusCodeSuccessFlag = proxySamlResponseStatusCodeSuccessFlag;
	}
	public SAMLObject getTargetSamlObject() {
		return targetSamlObject;
	}
	public void setTargetSamlObject(SAMLObject targetSamlObject) {
		this.targetSamlObject = targetSamlObject;
	}
	
	public String getProxyStatusCode() {
		return proxyStatusCode;
	}
	public void setProxyStatusCode(String statusCode) {
		this.proxyStatusCode = statusCode;
	}

	public String toString(){
		StringBuffer sb = null;
		try {
			sb = new StringBuffer();
			sb.append("\n");
			//sb.append("\t");sb.append("[");sb.append("SOURCE");sb.append("]");sb.append("\n");
			//sb.append("\t\t");sb.append("[");sb.append("sourceRelayState: ");sb.append(getSourceRelayState());sb.append("]");sb.append("\n");
			sb.append("\t");sb.append("[");sb.append("PROXY");sb.append("]");sb.append("\n");
			sb.append("\t\t");sb.append("[");sb.append("proxyUrl: ");sb.append(getProxyUrl());sb.append("]");sb.append("\n");
			sb.append("\t\t");sb.append("[");sb.append("proxySamlIssuer: ");sb.append(getProxySamlIssuer());sb.append("]");sb.append("\n");			
			sb.append("\t\t");sb.append("[");sb.append("proxyRelayState: ");sb.append(getProxyRelayState());sb.append("]");sb.append("\n");
			sb.append("\t\t");sb.append("[");sb.append("proxyValidateSignFlag: ");sb.append(getProxyValidateSignFlag());sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxyValidateSignAchievedFlag: ");sb.append(getProxyValidateSignAchievedFlag());sb.append("]");sb.append("\n");
			sb.append("\t\t");sb.append("[");sb.append("proxySignFlag: ");sb.append(getProxySignFlag());sb.append("]");sb.append("\n");
			sb.append("\t\t\t ");sb.append("[");sb.append("proxySignAchievedFlag: ");sb.append(getProxySignAchievedFlag());sb.append("]");sb.append("\n");
			sb.append("\t\t");sb.append("[");sb.append("proxyValidateSignCertFilePath: ");sb.append(getProxyValidateSignCertFilePath());sb.append("]");sb.append("\n");
			sb.append("\t\t");sb.append("[");sb.append("proxyTranslationParameters");sb.append("]");sb.append("\n");			
			/*sb.append("\t\t\t");sb.append("[");sb.append("proxyFromLocale: ");sb.append(getProxyFromLocale());sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxyFromResourceBundleBaseName: ");sb.append(getProxyFromResourceBundleBaseName());sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxyToLocale: ");sb.append(getProxyToLocale());sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxyToResourceBundleBaseName: ");sb.append(getProxyToResourceBundleBaseName());sb.append("]");sb.append("\n");
			*/
			sb.append("\t\t");sb.append("[");sb.append("proxyAuthenticationParameters");sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxySamlIdpProvider: ");sb.append(getProxySamlIdpProvider());sb.append("]");sb.append("\n");
			sb.append("\t\t");sb.append("[");sb.append("proxySubjectQueryParameters");sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxySamlSubjectNameId: ");sb.append(getProxySamlSubjectNameId());sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxySamlSubjectNameQualifier: ");sb.append(getProxySamlSubjectNameQualifier());sb.append("]");sb.append("\n");
			sb.append("\t\t");sb.append("[");sb.append("proxyAuthorizationParameters");sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxySamlActionId: ");sb.append(getProxySamlActionId());sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxySamlResourceId: ");sb.append(getProxySamlResourceId());sb.append("]");sb.append("\n");
			sb.append("\t\t");sb.append("[");sb.append("proxyAttributeQueryParameters");sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxySamlAttributes: ");sb.append("");sb.append("]");sb.append("\n");
			sb.append("\t\t");sb.append("[");sb.append("proxyResponseParameters");sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxySamlInResponseTo: ");sb.append(getProxySamlInResponseTo());sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxySamlInResponseToType: ");sb.append(getProxySamlInResponseToType());sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxySamlAssertionList: ");sb.append(getProxySamlAssertionList());sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxyEncryptFlag: ");sb.append(getProxyEncryptFlag());sb.append("]");sb.append("\n");
			sb.append("\t\t\t\t");sb.append("[");sb.append("proxyEncryptAchievedAssertionNumber: ");sb.append(getProxyEncryptAchievedAssertionNumber());sb.append("]");sb.append("\n");			
			sb.append("\t\t\t");sb.append("[");sb.append("proxyEncryptCertFilePath: ");sb.append(getProxyEncryptCertFilePath());sb.append("]");sb.append("\n");
			sb.append("\t\t\t");sb.append("[");sb.append("proxySamlResponseStatusCodeSuccessFlag: ");sb.append(getProxySamlResponseStatusCodeSuccessFlag());sb.append("]");sb.append("\n");
		} catch (Exception e){
			sb = new StringBuffer();
			sb.append("ToStringException: " + e.getMessage());
		}
		return sb.toString();
	}
	
}
