package eu.semiramis.federationproxy.wayf;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

import eu.semiramis.federationproxy.route.RouteBean;
import eu.semiramis.federationproxy.route.RouteManager;

public class WAYFManager {
	protected static Logger logger = Logger.getLogger(RouteManager.class);
	private static WAYFManager wayfManagerSingleInstance = null;
	private RouteBean[] fullRouteBeanArray = null;
	
	public static void init(RouteBean[] routeBeanArray) throws Exception{
		logger.debug("[WAYFManager.init()] Start");
		if (wayfManagerSingleInstance == null){
			wayfManagerSingleInstance = new WAYFManager(routeBeanArray);
		}
		logger.debug("[WAYFManager.init()] End");
	}
	private WAYFManager(){}
	private WAYFManager(RouteBean[] r) {
		this.fullRouteBeanArray = r;
	}
	
	public static WAYFManager getInstance(){
		return wayfManagerSingleInstance;
	}
	public List<RouteBean> getWAYFRouteList(String routeType) {
		List<RouteBean> wayfRouteBeanList = new ArrayList<RouteBean>();
		for(RouteBean r : fullRouteBeanArray) {
			if(r.getRouteType().equals(routeType)) {
				wayfRouteBeanList.add(r);
			}
		}
		return wayfRouteBeanList;
	}
}
