package eu.semiramis.format;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.text.NumberFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Locale;
import java.util.Properties;
import java.util.Set;
import java.util.Vector;

public class FormatUtil {
	public final static int	MAXLENGTH = 2000;
	//public final static String LIST_PREFIX = "\n{";
	//public final static String LIST_SUFIX = "\n}";
	public final static String LIST_PREFIX = "\n<LIST>";
	public final static String LIST_SUFIX = "\n</LIST>";
	
	public final static String COMPLEXITEM_PREFIX = "[";
	public final static String COMPLEXITEM_SUFIX = "]";
	public final static String ITEM_PREFIX = "(";
	public final static String ITEM_SUFIX = ")";
	
	/*
	public static String toHtml(Object o){
		StringBuffer sb = new StringBuffer();		
		if (o == null){
			sb = new StringBuffer();
		} else if (o instanceof String){
			String str = (String) o;
			if (str != null){
				sb.append(str);
			}
		} else {
			sb.append(toHtml(o.toString()));
		}
		return sb.toString();
	}	
	*/
	
	
	/**
	 * toString
	 * @param key
	 * @param value
	 * @return
	 */	
	public static String toString(String key, Object value){
		StringBuffer sb = new StringBuffer();
		if (value != null && key != null){
			String formatedValue = FormatUtil.toString(value); 
			sb.append(ITEM_PREFIX).append(key).append(":").append(formatedValue).append(ITEM_SUFIX);
		}
		return sb.toString(); 
	}
	/**
	 * toString
	 * @param o
	 * @return
	 */
	public static String toString(Object o){
		StringBuffer sb = new StringBuffer();
		sb.append(o);		
		try{
			if (o == null){
				sb = new StringBuffer();sb.append(o);
			} else if (o instanceof String){
				sb = new StringBuffer();sb.append(o);
			} else if (o instanceof Number){
				Number number = (Number) o;
				NumberFormat numberFormat = NumberFormat.getInstance();
				String str = numberFormat.format(number);
				sb = new StringBuffer();sb.append(str);
			} else if (o instanceof Integer) {
				sb = new StringBuffer();sb.append(o);								
			} else if (o instanceof Date){
				Date date = (Date) o;
				sb = new StringBuffer();
				sb.append(toString(date, DATEPATTERN_DEFAULT, LOCALE_DEFAULT));
			} else if (o instanceof ArrayList) {
				sb = new StringBuffer();
				ArrayList arrayList = (ArrayList) o;
				Iterator arrayListIterator = arrayList.iterator();
				sb.append(toString(arrayListIterator));
			} else if (o instanceof Set) {
				sb = new StringBuffer();
				Set set = (Set) o;
				Iterator arrayListIterator = set.iterator();
				sb.append(toString(arrayListIterator));
			} else if (o instanceof Vector){
				Vector vector = (Vector) o;
				Enumeration enumeration = vector.elements();
				sb.append(toString(enumeration));
			} else if (o instanceof Object[]){
				sb = new StringBuffer();
				Object[] objectArray = (Object[]) o;
				int objectArrayLength = objectArray.length;
				sb.append(LIST_PREFIX);
				//sb.append(objectArrayLength);sb.append(" elements");sb.append("\n");
				for (int i = 0; i < objectArrayLength; i ++){
					sb.append("\n").append(toString(objectArray[i]));
				}
				sb.append(LIST_SUFIX);
			} else if (o instanceof Properties) {
				sb = new StringBuffer();
				Properties properties = (Properties) o;
				sb.append(LIST_PREFIX);
				//sb.append(properties.size());sb.append(" elements");sb.append("\n");
				Enumeration propertiesKeys = properties.keys();
				while (propertiesKeys.hasMoreElements()){
					String key = (String) propertiesKeys.nextElement();
					String value = properties.getProperty(key);
					sb.append("\n").append(toString(key, value));
				}
				sb.append(LIST_SUFIX);
			} else if (o instanceof Enumeration){
				sb = new StringBuffer();
				Enumeration enumeration = (Enumeration) o;
				sb.append(LIST_PREFIX);
				while (enumeration.hasMoreElements()){
					Object enumerationItem = enumeration.nextElement();
					sb.append("\n").append(toString(enumerationItem));
				}
				sb.append(LIST_SUFIX);
			} else if (o instanceof Iterator){
				sb = new StringBuffer();
				Iterator iterator = (Iterator) o;
				sb.append(LIST_PREFIX);
				while (iterator.hasNext()){
					Object item = iterator.next();
					sb.append("\n").append(toString(item));
				}
				sb.append(LIST_SUFIX);
			} else if (o instanceof Throwable) {
				sb = new StringBuffer();
				StringWriter stringWriter = null;
				PrintWriter printWriter = null;
				try {
					Throwable throwable = (Throwable) o;
					stringWriter = 	new StringWriter();
					printWriter = new PrintWriter(stringWriter, true);
					throwable.printStackTrace(printWriter);
					printWriter.flush();
					stringWriter.flush();
					sb.append("\n").append(stringWriter.toString());
				} finally {
					if (printWriter != null){
						printWriter.close();
					}
					if (stringWriter != null){
						stringWriter.close();
					}
				}
			}
			//} else if (o instanceof TreeMap) {
			//	sb = new StringBuffer();
			//	TreeMap treeMap = (TreeMap) o;
			//	sb.append(LIST_PREFIX);
			//	//sb.append(treeMap.size());sb.append(" elements");sb.append("\n");
			//	sb.append(treeMap.toString());
			//	sb.append(LIST_SUFIX);
	
			
			String toString = sb.toString();
			//toString = StringUtil.replace(toString, LIST_PREFIX, "\n" + LIST_PREFIX);
			//toString = StringUtil.replace(toString, LIST_SUFIX, LIST_SUFIX + "\n");
			//toString = StringUtil.replace(toString, COMPLEXITEM_PREFIX, "\n" + COMPLEXITEM_PREFIX);
			//toString = StringUtil.replace(toString, COMPLEXITEM_SUFIX, COMPLEXITEM_SUFIX + "\n");
			//toString = StringUtil.replace(toString, "\n\n", "\n");
			return toString;
			//int jobLength = MAXLENGTH;
			//while (sb.length() > jobLength){
			//	sb.insert(jobLength, '\n');
			//	jobLength = jobLength + MAXLENGTH; 
			//}
			//return sb.toString();
		} catch (Exception e){
			sb = new StringBuffer();
			sb.append(o).append("_toStringException");
			return sb.toString();
		}
	}
	/**
	 * El metodo toString de la clase DateTimeUtil es mucho mas eficiente.
	 * 
	 * @param date
	 * @param pattern
	 * @param locale
	 * @return
	 */
	public static String toString(Date date, String pattern, Locale locale){
		String dateStream = null;
		if (date != null){
			if(pattern == null){
				pattern = DATEPATTERN_DEFAULT;
			}
			if (locale == null){
				locale = LOCALE_DEFAULT;
			}
			SimpleDateFormat sdf = new SimpleDateFormat(pattern, locale);
			dateStream = sdf.format(date);
		}
		return dateStream;
	}
	
	public final static String DATEPATTERN_DEFAULT = "dd/MM/yyyy";
	public final static Locale LOCALE_DEFAULT = Locale.getDefault();
	 
	/**
	 * El metodo toDate de la clase FormatUtil es mucho mas eficiente
	 * @param str
	 * @return
	 * @throws ParseException
	 */
	public static Date toDate(String str) throws ParseException{
		Date date = toDate(str, DATEPATTERN_DEFAULT, LOCALE_DEFAULT);
		return date;
	}
	/**
	 * 
	 * @param dateStream
	 * @param pattern
	 * @param locale
	 * @return
	 * @throws ParseException
	 */
	public static Date toDate(String dateStream, String pattern, Locale locale) throws ParseException{
		Date date = null;
		if (dateStream != null) {		
			if (pattern == null){
				pattern = DATEPATTERN_DEFAULT;
			}
			if (locale == null){
				locale = LOCALE_DEFAULT;
			}
			SimpleDateFormat sdf = new SimpleDateFormat(pattern, locale);
			date = sdf.parse(dateStream);
		}
		return date;
	}
	
	/**
	 * 
	 * @param str
	 * @return
	 * @throws ParseException
	 */
	public static Number toNumber(String str) throws ParseException{
		NumberFormat numberFormat = NumberFormat.getInstance();
		Number number = numberFormat.parse(str);
		return number;
	}
	
	/**
	 * toBoolean
	 * @param o
	 * @return
	 */
	public static Boolean toBoolean(Object o){
		Boolean toBoolean = null;
		if (o == null){
			toBoolean = null;
		} else if (o instanceof String){
			String s = (String) o;
			toBoolean = new Boolean(s);
		}
		return toBoolean;
	}
	
	/**
	 * Integer
	 * @param o
	 * @return
	 */
	public static Integer toInteger(Object o){
		Integer toInteger = null;
		if (o == null){
			toInteger = null;
		} else if (o instanceof String){
			String s = (String) o;
			toInteger = new Integer(s);
		}
		return toInteger;
	}
}
