package eu.semiramis.util.string;

public class StringUtil {

	public static final String STRING_EMPTY		= "";
	public static final String STRING_NULL		= "null";
	/**
	 * isNotEmpty
	 * @param s
	 * @return
	 */
	public static boolean isNotEmpty(String s){
		boolean isNotEmpty = false;
		if (s != null && !STRING_EMPTY.equals(s.trim())){
			isNotEmpty = true;
		}
		return isNotEmpty;
	}
	/**
	 * isEmpty
	 * @param o
	 * @return
	 */
	public static boolean isEmpty(Object o){
		boolean flag = false;
		if (o != null){
			if (o instanceof String){
				String s = (String) o;
				if (STRING_EMPTY.equals(s)){
					flag = true;
				}
			}
		}
		return flag; 
	}
	/**
	 * isTrimEmpty
	 * @param o
	 * @return
	 */
	public static boolean isTrimEmpty(Object o){
		boolean flag = false;
		if (o != null){
			if (o instanceof String){
				String s = ((String) o).trim();
				flag = isEmpty(s);
			}
		}
		return flag; 
	}
	/**
	 * isNullOrEmpty
	 * @param o
	 * @return
	 */
	public static boolean isNullOrEmpty(Object o){
		boolean flag = false;
		if (o == null || isEmpty(o)){
			flag = true;
		}
		return flag;
	}
	/**
	 * isNullOrTrimEmpty
	 * @param o
	 * @return
	 */
	public static boolean isNullOrTrimEmpty(Object o){
		boolean flag = false;
		if (o == null || isTrimEmpty(o)){
			flag = true;
		}
		return flag;
	}
	/**
	 * Method to replace a section of a String by another string.
	 * @param receivedSource: The String where replace the text int
	 * @param ori: The String to search and replace
	 * @param des: The String to replace by
	 * @return: The string resulting of the replacement.
	 */
	public static String replace(String receivedSource, String ori, String des) {
		int lastIndex = 0;
		int index;
		String resultSource = receivedSource;
		StringBuffer sb = new StringBuffer(resultSource);
		index = resultSource.indexOf(ori);		
		while (index > -1 && index >= lastIndex) {
			sb = new StringBuffer(resultSource.substring(0, index));
			sb.append(des);
			sb.append(resultSource.substring(index + ori.length()));
			resultSource = sb.toString();
			lastIndex = index + des.length();
			index = resultSource.indexOf(ori, lastIndex);
		}
		return resultSource;
	}
	/**
	 * Method to replace a section of a String by another string.The replace is independent od the case.<br>
	 * @param receivedSource: The String where replace the text int
	 * @param ori: The String to search and replace
	 * @param des: The String to replace by
	 * @return: The string resulting of the replacement.
	 */
	public static String replaceInsensitive(String receivedSource, String ori, String des) {
		int lastIndex = 0;
		int index;
		String resultSource = receivedSource;
		String upperSource = receivedSource.toUpperCase();
		String upperOri = ori.toUpperCase();
		StringBuffer upperSb = new StringBuffer(upperSource);
		StringBuffer sb = new StringBuffer(receivedSource);
		index = upperSource.indexOf(upperOri);		
		while (index > -1 && index >= lastIndex) {
			upperSb = new StringBuffer(upperSource.substring(0, index));
			sb = new StringBuffer(resultSource.substring(0, index));
			upperSb.append(des);
			sb.append(des);
			upperSb.append(upperSource.substring(index + ori.length()));
			sb.append(resultSource.substring(index + ori.length()));
			upperSource = upperSb.toString();
			resultSource = sb.toString();
			lastIndex = index + des.length();
			index = upperSource.indexOf(upperOri, lastIndex);
		}
		return resultSource;
	}
	/**
	 * 
	 * @param text
	 * @param maxLength
	 * @return
	 */
	public static String cut(String text, int maxLength) {
		if (text == null){
			return "";
		}
		if (text.length() > maxLength) {
			return text.substring(0, maxLength);
		} else {
			return text;
		}
	}
	/**
	 * capitalize
	 * @param s
	 * @return
	 */
	public static String capitalize(String s) {
		char chars[] = s.toCharArray();
		chars[0] = Character.toUpperCase(chars[0]);
		return new String(chars);
	}
	/**
	 * equals
	 * @param a
	 * @param b
	 * @return
	 */
	public static boolean equals(String a, String b){
		boolean result = false;
		if (a == null && b == null){
			result = true;
		} else if(a != null && b != null){
			if (a.equals(b)){
				result = true;
			}
		}
		return result;
	}
}
