package eu.semiramis.util.updown;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.OutputStream;
import java.util.Properties;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;

import eu.semiramis.util.file.FileUtil;
import eu.semiramis.util.string.StringUtil;
import eu.semiramis.util.zip.ZipUtil;

/**
 *
 * Cuando se genera PDF con itext, para que funcione download as attachment, es necesario setear
 * response.setHeader("Cache-control", "public"); para que funcione correctamente en ele explorer  
 */
public class DownloadUtil {
	public static int BUFFERSIZE = 4096;
	public final static String KEY_FILEPATH = "FilePath";
	public final static String KEY_FILENAME = "FileName";
	public final static String KEY_CONTENTTYPE = "Content-Type";
	private final static String KEY_CONTENTDISPOSITION = "Content-Disposition";
	private final static String KEY_CACHECONTROL = "Cache-control";
	private final static String KEY_PRAGMA = "Pragma";
	private final static String KEY_EXPIRES = "Expires";
	

	
	
	public final static String VALUE_CONTENTDISPOSITIONTYPE_INLINE = "inline";
	public final static String VALUE_CONTENTDISPOSITIONTYPE_ATTACHMENT = "attachment";
	
	public static Properties EXTENSIONPROPERTIES = null;
	static {
		EXTENSIONPROPERTIES = new Properties();
		EXTENSIONPROPERTIES.setProperty("abs", "audio/x-mpeg");
		EXTENSIONPROPERTIES.setProperty("ai", "application/postscript");
		EXTENSIONPROPERTIES.setProperty("aif", "audio/x-aiff");
		EXTENSIONPROPERTIES.setProperty("aifc", "audio/x-aiff");
		EXTENSIONPROPERTIES.setProperty("aiff", "audio/x-aiff");
		EXTENSIONPROPERTIES.setProperty("aim", "application/x-aim");
		EXTENSIONPROPERTIES.setProperty("art", "image/x-jg");
		EXTENSIONPROPERTIES.setProperty("asf", "video/x-ms-asf");
		EXTENSIONPROPERTIES.setProperty("asx", "video/x-ms-asf");
		EXTENSIONPROPERTIES.setProperty("au", "audio/basic");
		EXTENSIONPROPERTIES.setProperty("avi", "video/x-msvideo");
		EXTENSIONPROPERTIES.setProperty("avx", "video/x-rad-screenplay");
		EXTENSIONPROPERTIES.setProperty("bcpio", "application/x-bcpio");
		EXTENSIONPROPERTIES.setProperty("bin", "application/octet-stream");
		EXTENSIONPROPERTIES.setProperty("bmp", "image/bmp");
		EXTENSIONPROPERTIES.setProperty("body", "text/html");
		EXTENSIONPROPERTIES.setProperty("cdf", "application/x-cdf");
		EXTENSIONPROPERTIES.setProperty("cer", "application/x-x509-ca-cert");
		EXTENSIONPROPERTIES.setProperty("class", "application/java");
		EXTENSIONPROPERTIES.setProperty("cpio", "application/x-cpio");
		EXTENSIONPROPERTIES.setProperty("csh", "application/x-csh");
		EXTENSIONPROPERTIES.setProperty("css", "text/css");
		EXTENSIONPROPERTIES.setProperty("dib", "image/bmp");
		EXTENSIONPROPERTIES.setProperty("doc", "application/msword");
		EXTENSIONPROPERTIES.setProperty("dtd", "text/plain");
		EXTENSIONPROPERTIES.setProperty("dv", "video/x-dv");
		EXTENSIONPROPERTIES.setProperty("dvi", "application/x-dvi");
		EXTENSIONPROPERTIES.setProperty("eps", "application/postscript");
		EXTENSIONPROPERTIES.setProperty("etx", "text/x-setext");
		EXTENSIONPROPERTIES.setProperty("exe", "application/octet-stream");
		EXTENSIONPROPERTIES.setProperty("gif", "image/gif");
		EXTENSIONPROPERTIES.setProperty("gtar", "application/x-gtar");
		EXTENSIONPROPERTIES.setProperty("gz", "application/x-gzip");
		EXTENSIONPROPERTIES.setProperty("hdf", "application/x-hdf");
		EXTENSIONPROPERTIES.setProperty("hqx", "application/mac-binhex40");
		EXTENSIONPROPERTIES.setProperty("htc", "text/x-component");
		EXTENSIONPROPERTIES.setProperty("htm", "text/html");
		EXTENSIONPROPERTIES.setProperty("html", "text/html");
		EXTENSIONPROPERTIES.setProperty("hqx", "application/mac-binhex40");
		EXTENSIONPROPERTIES.setProperty("ief", "image/ief");
		EXTENSIONPROPERTIES.setProperty("jad", "text/vnd.sun.j2me.app-descriptor");
		EXTENSIONPROPERTIES.setProperty("jar", "application/java-archive");
		EXTENSIONPROPERTIES.setProperty("java", "text/plain");
		EXTENSIONPROPERTIES.setProperty("jnlp", "application/x-java-jnlp-file");
		EXTENSIONPROPERTIES.setProperty("jpe", "image/jpeg");
		EXTENSIONPROPERTIES.setProperty("jpeg", "image/jpeg");
		EXTENSIONPROPERTIES.setProperty("jpg", "image/jpeg");
		EXTENSIONPROPERTIES.setProperty("js", "text/javascript");
		EXTENSIONPROPERTIES.setProperty("kar", "audio/x-midi");
		EXTENSIONPROPERTIES.setProperty("latex", "application/x-latex");
		EXTENSIONPROPERTIES.setProperty("m3u", "audio/x-mpegurl");
		EXTENSIONPROPERTIES.setProperty("mac", "image/x-macpaint");
		EXTENSIONPROPERTIES.setProperty("man", "application/x-troff-man");
		EXTENSIONPROPERTIES.setProperty("me", "application/x-troff-me");
		EXTENSIONPROPERTIES.setProperty("mid", "audio/x-midi");
		EXTENSIONPROPERTIES.setProperty("midi", "audio/x-midi");
		EXTENSIONPROPERTIES.setProperty("mif", "application/x-mif");
		EXTENSIONPROPERTIES.setProperty("mov", "video/quicktime");
		EXTENSIONPROPERTIES.setProperty("movie", "video/x-sgi-movie");
		EXTENSIONPROPERTIES.setProperty("mp1", "audio/x-mpeg");
		EXTENSIONPROPERTIES.setProperty("mp2", "audio/x-mpeg");
		EXTENSIONPROPERTIES.setProperty("mp3", "audio/x-mpeg");
		EXTENSIONPROPERTIES.setProperty("mpa", "audio/x-mpeg");
		EXTENSIONPROPERTIES.setProperty("mpe", "video/mpeg");
		EXTENSIONPROPERTIES.setProperty("mpeg", "video/mpeg");
		EXTENSIONPROPERTIES.setProperty("mpega", "audio/x-mpeg");
		EXTENSIONPROPERTIES.setProperty("mpg", "video/mpeg");
		EXTENSIONPROPERTIES.setProperty("mpv2", "video/mpeg2");
		EXTENSIONPROPERTIES.setProperty("ms", "application/x-wais-source");
		EXTENSIONPROPERTIES.setProperty("nc", "application/x-netcdf");
		EXTENSIONPROPERTIES.setProperty("oda", "application/oda");
		EXTENSIONPROPERTIES.setProperty("pbm", "image/x-portable-bitmap");
		EXTENSIONPROPERTIES.setProperty("pct", "image/pict");
		EXTENSIONPROPERTIES.setProperty("pdf", "application/pdf");
		EXTENSIONPROPERTIES.setProperty("pgm", "image/x-portable-graymap");
		EXTENSIONPROPERTIES.setProperty("pic", "image/pict");
		EXTENSIONPROPERTIES.setProperty("pict", "image/pict");
		EXTENSIONPROPERTIES.setProperty("pls", "audio/x-scpls");
		EXTENSIONPROPERTIES.setProperty("png", "image/png");
		EXTENSIONPROPERTIES.setProperty("pnm", "image/x-portable-anymap");
		EXTENSIONPROPERTIES.setProperty("pnt", "image/x-macpaint");
		EXTENSIONPROPERTIES.setProperty("ppm", "image/x-portable-pixmap");
		EXTENSIONPROPERTIES.setProperty("ps", "application/postscript");
		EXTENSIONPROPERTIES.setProperty("psd", "image/x-photoshop");
		EXTENSIONPROPERTIES.setProperty("qt", "video/quicktime");
		EXTENSIONPROPERTIES.setProperty("qti", "image/x-quicktime");
		EXTENSIONPROPERTIES.setProperty("qtif", "image/x-quicktime");
		EXTENSIONPROPERTIES.setProperty("ras", "image/x-cmu-raster");
		EXTENSIONPROPERTIES.setProperty("rgb", "image/x-rgb");
		EXTENSIONPROPERTIES.setProperty("rm", "application/vnd.rn-realmedia");
		EXTENSIONPROPERTIES.setProperty("roff", "application/x-troff");
		EXTENSIONPROPERTIES.setProperty("rtf", "application/rtf");
		EXTENSIONPROPERTIES.setProperty("rtx", "text/richtext");
		EXTENSIONPROPERTIES.setProperty("sh", "application/x-sh");
		EXTENSIONPROPERTIES.setProperty("shar", "application/x-shar");
		EXTENSIONPROPERTIES.setProperty("smf", "audio/x-midi");
		EXTENSIONPROPERTIES.setProperty("snd", "audio/basic");
		EXTENSIONPROPERTIES.setProperty("src", "application/x-wais-source");
		EXTENSIONPROPERTIES.setProperty("sv4cpio", "application/x-sv4cpio");
		EXTENSIONPROPERTIES.setProperty("sv4crc", "application/x-sv4crc");
		EXTENSIONPROPERTIES.setProperty("swf", "application/x-shockwave-flash");
		EXTENSIONPROPERTIES.setProperty("t", "application/x-troff");
		EXTENSIONPROPERTIES.setProperty("tar", "application/x-tar");
		EXTENSIONPROPERTIES.setProperty("tcl", "application/x-tcl");
		EXTENSIONPROPERTIES.setProperty("tex", "application/x-tex");
		EXTENSIONPROPERTIES.setProperty("texi", "application/x-texinfo");
		EXTENSIONPROPERTIES.setProperty("texinfo", "application/x-texinfo");
		EXTENSIONPROPERTIES.setProperty("tif", "image/tiff");
		EXTENSIONPROPERTIES.setProperty("tiff", "image/tiff");
		EXTENSIONPROPERTIES.setProperty("tr", "application/x-troff");
		EXTENSIONPROPERTIES.setProperty("tsv", "text/tab-separated-values");
		EXTENSIONPROPERTIES.setProperty("txt", "text/plain");
		EXTENSIONPROPERTIES.setProperty("ulw", "audio/basic");
		EXTENSIONPROPERTIES.setProperty("ustar", "application/x-ustar");
		EXTENSIONPROPERTIES.setProperty("xbm", "image/x-xbitmap");
		EXTENSIONPROPERTIES.setProperty("xpm", "image/x-xpixmap");
		EXTENSIONPROPERTIES.setProperty("xwd", "image/x-xwindowdump");
		EXTENSIONPROPERTIES.setProperty("wav", "audio/x-wav");
		EXTENSIONPROPERTIES.setProperty("wbmp", "image/vnd.wap.wbmp");
		EXTENSIONPROPERTIES.setProperty("wml", "text/vnd.wap.wml");
		EXTENSIONPROPERTIES.setProperty("wmlc", "application/vnd.wap.wmlc");
		EXTENSIONPROPERTIES.setProperty("wmls", "text/vnd.wap.wmls");
		EXTENSIONPROPERTIES.setProperty("wmlscriptc", "application/vnd.wap.wmlscriptc");
		EXTENSIONPROPERTIES.setProperty("wrl", "x-world/x-vrml");
		EXTENSIONPROPERTIES.setProperty("Z", "application/x-compress");
		EXTENSIONPROPERTIES.setProperty("z", "application/x-compress");
		EXTENSIONPROPERTIES.setProperty("zip", "application/zip");
		EXTENSIONPROPERTIES.setProperty("ppt", "application/vnd.ms-powerpoint");
		EXTENSIONPROPERTIES.setProperty("xls", "application/vnd.ms-excel");
		EXTENSIONPROPERTIES.setProperty("xml", "application/xml");
	}
	
	public static HttpServletResponse downloadAsInline(HttpServletResponse response, String filePath) throws Exception{
		String fileName = null;
		if (filePath != null){
			fileName = FileUtil.getFileName(filePath); 
		}
		return downloadAsInline(response, fileName, filePath);
	}
	public static HttpServletResponse downloadAsInline(HttpServletResponse response, String fileName, String filePath) throws Exception{
		String contentDispositionType = VALUE_CONTENTDISPOSITIONTYPE_INLINE;
		return download(response, contentDispositionType, fileName, filePath);
	}
	public static HttpServletResponse downloadAsAttachment(HttpServletResponse response, String filePath) throws Exception{
		String fileName = null;
		if (filePath != null){
			fileName = FileUtil.getFileName(filePath); 
		}
		return downloadAsAttachment(response, fileName, filePath);
	}
	public static HttpServletResponse downloadAsAttachment(HttpServletResponse response, String fileName, String filePath) throws Exception{
		String contentDispositionType = VALUE_CONTENTDISPOSITIONTYPE_ATTACHMENT;
		return download(response, contentDispositionType, fileName, filePath);
	}
	public static HttpServletResponse downloadAsInline(HttpServletResponse response, String fileName, byte[] byteArray) throws Exception{
		String contentDispositionType = VALUE_CONTENTDISPOSITIONTYPE_INLINE;
		return download(response, contentDispositionType, fileName, byteArray);
	}
	public static HttpServletResponse downloadAsAttachment(HttpServletResponse response, String fileName, byte[] byteArray) throws Exception{
		String contentDispositionType = VALUE_CONTENTDISPOSITIONTYPE_ATTACHMENT;
		return download(response, contentDispositionType, fileName, byteArray);
	}
	public static HttpServletResponse downloadAsZipAttachment(HttpServletResponse response, String fileName, String filePath) throws Exception{
		String contentDispositionType = VALUE_CONTENTDISPOSITIONTYPE_ATTACHMENT;
		return zipDownload(response, contentDispositionType, fileName, filePath);
	}
	public static HttpServletResponse downloadAsZipAttachment(HttpServletResponse response, String fileName, byte[] byteArray) throws Exception{
		String contentDispositionType = VALUE_CONTENTDISPOSITIONTYPE_ATTACHMENT;
		return zipDownload(response, contentDispositionType, fileName, byteArray);
	}
	/**
	 * 
	 * @param response
	 * @param contentDispositionType
	 * @param fileName
	 * @param source
	 * @return
	 * @throws Exception
	 */	
	private static HttpServletResponse download(HttpServletResponse response, String contentDispositionType, String fileName, Object source) throws Exception{
		boolean isDownloable = isDownloable(source);
		if (isDownloable){
			response = configureServletResponse(response, contentDispositionType, fileName, source);
			writeServletOutputStream(response, source);
		} else {
			response.sendError(404);
		}
		return response;
	}
	/**
	 * 
	 * @param response
	 * @param contentDispositionType
	 * @param fileName
	 * @param source
	 * @return
	 * @throws Exception
	 */
	private static HttpServletResponse zipDownload(HttpServletResponse response, String contentDispositionType, String fileName, Object source) throws Exception{
		boolean isDownloable = isDownloable(source);
		if (isDownloable){
			String fileExtension = FileUtil.getFileNameExtension(fileName);
			String zipFileName = StringUtil.replace(fileName, fileExtension, ".zip");
			response = configureServletResponse(response, contentDispositionType, zipFileName, null);
			OutputStream servletOutputStream = response.getOutputStream();
			if (source instanceof String){
				String filePath = (String) source; 
				servletOutputStream = ZipUtil.zipFile(filePath, servletOutputStream);	
			} else if (source instanceof byte[]){
				byte[] byteArray = (byte[]) source;
				servletOutputStream = ZipUtil.zipFile(byteArray, servletOutputStream, fileName);
			}
		} else {
			response.sendError(404);
		}
		return response;
	}
	
	
	/**
	 * isDownloable
	 * @param object
	 * @return
	 */
	private static boolean isDownloable(Object object){
		boolean isDownloable = false;
		if (object instanceof String) {
			String filePath = (String) object;
			if (filePath != null){
				if (FileUtil.isExistentFile(filePath)){
					isDownloable = true;
				}
			}
		} else if (object instanceof byte[]){
			byte[] byteArray = (byte[]) object;
			if (byteArray != null){
				int byteArrayLength = byteArray.length;
				if (byteArrayLength > 0){
					isDownloable = true;
				}
			}
		}
		return isDownloable;
	}
	/**
	 * 
	 * @param contentDispositionType
	 * @param fileName
	 * @return
	 */
	private static String getContentDisposition(String contentDispositionType, String fileName){
		StringBuffer sb = new StringBuffer();
		if (contentDispositionType == null){
			contentDispositionType = VALUE_CONTENTDISPOSITIONTYPE_ATTACHMENT;
		}
		sb.append(contentDispositionType);
		if (fileName != null){
			sb.append(";filename=").append(fileName);
		}
		return sb.toString();
	}
	/**
	 * 
	 * @param fileName
	 * @return
	 */
	private static String getContentType(String fileName){
		String contentType = null;
		if (fileName != null){
			String fileNameExtension = FileUtil.getFileNameExtension(fileName);
			if (fileNameExtension != null){
				String extensionPropertiesKey = fileNameExtension.substring(".".length(), fileNameExtension.length());
				contentType = EXTENSIONPROPERTIES.getProperty(extensionPropertiesKey);
			}	
		}
		return contentType;
	}
	/**
	 * writeServletOutputStream
	 * @param response
	 * @param filePath
	 * @throws Exception
	 */
	private static void writeServletOutputStream(HttpServletResponse response, Object source) throws Exception{
		ServletOutputStream servletOutputStream = null;
		FileInputStream fileInputStream = null;
		BufferedInputStream bufferedinputstream = null;
		try{
			if (source instanceof String){
				String filePath = (String) source;
				servletOutputStream = response.getOutputStream();
				fileInputStream = new FileInputStream(filePath);
				bufferedinputstream = new BufferedInputStream(fileInputStream);
				int i = 0;
				byte byteArray[] = new byte[BUFFERSIZE];
				while ((i = bufferedinputstream.read(byteArray)) != -1){
					servletOutputStream.write(byteArray, 0, i);
				}
				servletOutputStream.flush();
				servletOutputStream.close();
				fileInputStream.close();
				bufferedinputstream.close();
			} else if (source instanceof byte[]){
				byte[] byteArray = (byte[]) source;
				servletOutputStream = response.getOutputStream();
				servletOutputStream.flush();
				servletOutputStream.write(byteArray);
				servletOutputStream.flush();
				servletOutputStream.close();
			}
		} finally {
			if (servletOutputStream != null){
				servletOutputStream.close();	
			}
			if (fileInputStream != null){
				fileInputStream.close();
			}
			if (bufferedinputstream != null){
				bufferedinputstream.close();
			}
		}
	}
	/**
	 * configureServletResponse
	 * @param response
	 * @param contentDispositionType
	 * @param fileName
	 * @param source
	 * @return
	 */
	private static HttpServletResponse configureServletResponse(HttpServletResponse response, String contentDispositionType, String fileName, Object source){
		String contentType = getContentType(fileName);
		if (contentType != null){
			response.setContentType(contentType);
		}
		String contentDisposition = getContentDisposition(contentDispositionType, fileName);
		if (contentDisposition != null){
			response.setHeader(KEY_CONTENTDISPOSITION, contentDisposition);
		}
		int contentLength = -1;
		if (source instanceof String){
			contentLength = FileUtil.getFileDataLength((String) source);
			response.setContentLength(contentLength);	
		} else if (source instanceof byte[]){
			contentLength = ((byte[]) source).length;
			response.setContentLength(contentLength);
		}
		return response;
	}

}
