package eu.semiramis.util.updown;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
public class MultipartUtil {
	private static final int SIZE_THRESHOLD = 40960;
	public static final String KEY_FILENAME = "fileName";
	public static final String KEY_FILECONTENTTYPE = "fileContentType";
	public static final String KEY_FILESIZE = "fileSize";
	public static final String KEY_FILEBYTEARRAY = "fileByteArray";
	
	private HashMap multipartMap = null;
	 	
	private void parseRequest(HttpServletRequest request, ServletFileUpload servletFileUpload) throws Exception{
		List fileItemsList = servletFileUpload.parseRequest(request);
		Iterator iterator = fileItemsList.iterator();
		multipartMap = new HashMap();
		while (iterator.hasNext()){
			FileItem fileItem = (FileItem) iterator.next();
			String parameterName = fileItem.getFieldName();
			ArrayList parameterValueArrayList = new ArrayList();
			if (multipartMap.containsKey(parameterName)){
				parameterValueArrayList = (ArrayList)multipartMap.get(parameterName);
			}
			Object parameterValue = null;
			if (fileItem.isFormField()){
				parameterValue = fileItem.getString();				
			} else {
				String fileName = fileItem.getName();
				String fileContentType = fileItem.getContentType();
				Long fileSize = new Long(fileItem.getSize());
				byte[] fileByteArray = fileItem.get();
				parameterValue = new HashMap();
				((HashMap)parameterValue).put(KEY_FILENAME, fileName);
				((HashMap)parameterValue).put(KEY_FILECONTENTTYPE, fileContentType);
				((HashMap)parameterValue).put(KEY_FILESIZE, fileSize);
				((HashMap)parameterValue).put(KEY_FILEBYTEARRAY, fileByteArray);
			}
			parameterValueArrayList.add(parameterValue);			
			multipartMap.put(parameterName, parameterValueArrayList);
		}
	}
	/*
	public UploadUtil(HttpServletRequest request, String uploadDirectory) throws Exception {
		if (uploadDirectory != null){
			if (!FileUtil.isExistentDirectory(uploadDirectory)){
				FileUtil.createDirectory(uploadDirectory);
			}
			DiskFileItemFactory diskFileItemFactory = new DiskFileItemFactory();
			diskFileItemFactory.setSizeThreshold(SIZE_THRESHOLD); // bytes
			File uploadPath = new File(uploadDirectory);
			diskFileItemFactory.setRepository(uploadPath);
			ServletFileUpload servletFileUpload = new ServletFileUpload(diskFileItemFactory);
			servletFileUpload.setSizeMax(-1);
			//servletFileUpload.setSizeMax(81920); // bytes
			parseRequest(request, servletFileUpload);
		}
	}
	*/
	public MultipartUtil(HttpServletRequest request) throws Exception {
		if (isMultipartContent(request)){
			DiskFileItemFactory diskFileItemFactory = new DiskFileItemFactory();
			diskFileItemFactory.setSizeThreshold(SIZE_THRESHOLD); // bytes
			ServletFileUpload servletFileUpload = new ServletFileUpload(diskFileItemFactory);
			servletFileUpload.setSizeMax(-1);
			//servletFileUpload.setSizeMax(81920); // bytes
			parseRequest(request, servletFileUpload);
		}
	}
	public String[] getParameterNames() throws Exception{
		String[] parameterNames = new String[0];
		ArrayList arrayList = new ArrayList();
		if (multipartMap != null){
			Set keySet = multipartMap.keySet();
			Iterator keyIterator = keySet.iterator();
			while (keyIterator.hasNext()){
				String key = (String)keyIterator.next();
				arrayList.add(key);
			}
		}
		parameterNames = new String[arrayList.size()];
		parameterNames = (String[]) arrayList.toArray(parameterNames);
		return parameterNames;
	}
	public Object getParameter(String parameterName) throws Exception{
		Object parameterValue = null;
		if (multipartMap != null){
			Set keySet = multipartMap.keySet();
			Iterator keyIterator = keySet.iterator();
			while (keyIterator.hasNext()){
				String key = (String)keyIterator.next();
				if (key.equals(parameterName)){
					ArrayList arrayList = (ArrayList) multipartMap.get(key);
					if (arrayList.size() > 0 ){
						parameterValue = arrayList.get(0);						
					}
					break;
				}
			}
		}
		return parameterValue;
	}
	public Object[] getParameters(String parameterName) throws Exception{
		Object[] parameterValueArray = null;
		if (multipartMap != null){
			Set keySet = multipartMap.keySet();
			Iterator keyIterator = keySet.iterator();
			while (keyIterator.hasNext()){
				String key = (String)keyIterator.next();
				if (key.equals(parameterName)){
					ArrayList arrayList = (ArrayList) multipartMap.get(key);
					parameterValueArray = new Object[arrayList.size()];
					parameterValueArray = (Object[]) arrayList.toArray();
					break;
				}
			}
		}
		return parameterValueArray;
	}
	public static boolean isMultipartContent(HttpServletRequest request){
		return ServletFileUpload.isMultipartContent(request);		
	}
}
