package eu.semiramis.util.updown;
import java.io.File;
import java.util.ArrayList;

import eu.semiramis.util.file.FileUtil;

public class UpdownBean {
	private final static String KEY_LINENUMBER = "lineNumber";
	private final static String KEY_LINESTREAM = "lineStream";
	private String updownDir = null;
	private String updownMessage = null;
	 
	/**
	 * UpdownBean
	 * @param jobDir
	 */
	public UpdownBean (){
		updownDir = "./";
	}
	/**
	 * @return
	 */
	public File[] getUpdownDirFileArray() {
		ArrayList arrayList = new ArrayList();
		File[] files = FileUtil.listFiles(updownDir);
		if (files != null){
			int filesLength = files.length;
			for (int i = 0; i < filesLength; i ++){
				File file = files[i];
				if (FileUtil.isExistentFile(file)){
					arrayList.add(file);
				}
			}
		}
		File[] fileArray = new File[arrayList.size()];
		fileArray = (File[]) arrayList.toArray(fileArray);
		return fileArray;
	}
	/**
	 * getGetUpdownDirPath
	 * @return
	 */
	public String getUpdownDirAbsolutePath(){
		String updownDirPath = "";
		if (updownDir != null){
			File updownDirFile = new File(updownDir);
			updownDirPath = updownDirFile.getAbsolutePath();
		}
		return updownDirPath;
	}
	/**
	 * @return
	 */
	public String getUpdownDir() {
		return updownDir;
	}


	/**
	 * @param string
	 */
	public void setUpdownDir(String string) throws Exception{
		if (FileUtil.isExistentDirectory(string)){
			this.updownDir = string;
		} else {
			setUpdownMessage("UPDOWN ERROR: Inexistant Job Directory: " + string);
		}
	}

	/**
	 * @return
	 */
	public String getUpdownMessage() {
		return updownMessage;
	}

	/**
	 * @param string
	 */
	public void setUpdownMessage(String string) {
		updownMessage = string;
	}

}
